/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflarePermissionGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Account identifier tag.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.1.0/docs/data-sources/permission_group#account_id DataCloudflarePermissionGroup#account_id}
    */
    readonly accountId: string;
    /**
    * Permission Group identifier tag.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.1.0/docs/data-sources/permission_group#permission_group_id DataCloudflarePermissionGroup#permission_group_id}
    */
    readonly permissionGroupId: string;
}
export interface DataCloudflarePermissionGroupMeta {
}
export declare function dataCloudflarePermissionGroupMetaToTerraform(struct?: DataCloudflarePermissionGroupMeta): any;
export declare function dataCloudflarePermissionGroupMetaToHclTerraform(struct?: DataCloudflarePermissionGroupMeta): any;
export declare class DataCloudflarePermissionGroupMetaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePermissionGroupMeta | undefined;
    set internalValue(value: DataCloudflarePermissionGroupMeta | undefined);
    get key(): string;
    get value(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.1.0/docs/data-sources/permission_group cloudflare_permission_group}
*/
export declare class DataCloudflarePermissionGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_permission_group";
    /**
    * Generates CDKTF code for importing a DataCloudflarePermissionGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflarePermissionGroup to import
    * @param importFromId The id of the existing DataCloudflarePermissionGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.1.0/docs/data-sources/permission_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflarePermissionGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.1.0/docs/data-sources/permission_group cloudflare_permission_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflarePermissionGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflarePermissionGroupConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    get id(): string;
    private _meta;
    get meta(): DataCloudflarePermissionGroupMetaOutputReference;
    get name(): string;
    private _permissionGroupId?;
    get permissionGroupId(): string;
    set permissionGroupId(value: string);
    get permissionGroupIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
